// This file contains the main theme overrides for the django admin.
@import 'settings';
@import 'mixins';

body {
    color: $gray-800;

    // show content once ready class is added
    &:not(.ready) {
        #content {
            opacity: 0;
        }
    }
}

// outdatedbrowser.js
#outdated {
    z-index: 9999999 !important;
}

h1 {
    font-size: 18px;
    font-weight: 400;
    color: $gray-900;
}

thead {
    th,
    td {
        font-weight: normal;
    }
}

tr.row2 {
    background: darken($white, 1.5%);
}

small {
    font-size: 13px;
    letter-spacing: 0;
}

// form inputs
input[type=text],
input[type=password],
input[type=email],
input[type=url],
input[type=number],
textarea,
select,
.vTextField {
    border-radius: 3px;

    &:not(:focus) {
        background: lighten($gray-50, 3%);
    }
}

// buttons
.button,
input[type=submit],
.submit-row input {
}

// messagelist
ul.messagelist {
    li.warning {
        background-color: $yellow;
    }

    li.success {
        background-color: $green-light;
    }
}

// breadcrumbs
div.breadcrumbs {
    padding: 5px 30px;
    background: $gray-50;
    color: $black;
    border-bottom: solid 1px $gray-300;

    a,
    span {
        padding: 0 6px 0 2px;

        &:first-child {
            padding-left: 0;
        }
    }

    a {
        color: $gray-500;

        &:focus,
        &:hover {
            color: $gray-700;
        }

        &:not(:last-child) {
            &::after {
                content: '›';
                color: $black;
                margin-left: 10px;
            }
        }
    }

    @media(max-width: $tablet-width - 1px) {
        padding-left: 15px;
        padding-right: 15px;
    }
}


// Admin header
#header {
    position: fixed;
    z-index: 2000;
    top: 0;
    left: 0;
    width: 100%;
    height: 42px;
    line-height: 30px;
    background: $gray-900;
    padding: 6px 40px;
    box-sizing: border-box;

    a {
        &:link,
        &:visited {
            padding: 0 4px;
            font-size: 12px;
            letter-spacing: 0;
            font-weight: 600;
            color: $gray-200;
            text-transform: none;
            border: 0;

            &:hover {
                color: $white;
            }
        }
    }

    @media(max-width: $tablet-width - 1px) {
        padding-left: 12px;
        padding-right: 12px;
    }
}

#branding {
    h1 {
        font-size: 18px;
        line-height: 30px;

        a:link,
        a:visited {
            font-size: 15px;
            font-weight: 500;
            padding: 0 2px;
            color: $white;
        }
    }
}

#user-tools {
    font-size: 12px;
    letter-spacing: 0;
    font-weight: 600;
    color: $gray-200;
    text-transform: none;

    a {
        border-bottom-color: transparent;
        padding: 0 2px;
        font-weight: 400;

        &:focus,
        &:hover {
            color: $white;
            border-bottom-color: $white;
        }
    }

    strong {
        margin-right: 10px;
        text-transform: none;
        font-size: 12px;
    }
}

// Layout
#container {
    position: relative;

    @media (max-width: $desktop-width) {
        min-width: auto;
    }
}

body:not(.popup):not(.login) #container {
    padding-top: 42px;
}


#content {
    min-height: calc(100vh - 42px);
    padding-left: 30px;
    padding-right: 30px;

    @media(max-width: $tablet-width - 1px) {
        padding-left: 15px;
        padding-right: 15px;
    }
}

// Login page
.login {
    height: 70vh;
    display: flex;
    align-items: center;
    justify-content: center;

    #header {
        position: static;
    }

    #container {
        padding: 0;
        margin: 0 15px;
    }

    #content {
        min-height: 0;
    }
}
// object tools
.object-tools {
    a:link,
    a:visited {
        background-color: $gray-500;
        background-position: calc(100% - 8px);

        &:hover {
            background-color: $blue;
        }

        .icon {
            vertical-align: middle;
            font-size: 20px;
        }
    }

    @media(max-width: $tablet-width - 1px) {
        float: none;
        margin: 0 0 20px 0;

        li {
            float: none;
            display: inline-block;
            height: auto;

            a:link,
            a:visited {
                float: none;
                display: inline-block;
            }
        }
    }
}


// modules
.module caption,
.inline-group h2 {
    background: $gray-50;
    color: $gray-900;
    text-transform: none;
    border: solid 1px $gray-300;
    border-bottom: 0;
    border-radius: 2px;
}


.module h2 {
    background: transparent;
    color: $gray-900;
    border-bottom: solid 1px $gray-300;
    padding-left: 2px;
    font-size: 18px;
    margin-bottom: 5px;

    a:link,
    a:visited {
        color: $gray-900;
    }
}


.module caption a:link,
.module caption a:visited {
    color: $gray-900;
}

.module table {
    border: solid 1px $gray-300;
}


// content-related
// used for history on index page
#content-related {
    background: $white;
    border: solid 1px $gray-300;

    .module {
        h2 {
            background: $gray-50;
            color: $gray-900;
            font-size: inherit;
            border: 0;
            border-bottom: solid 1px $gray-300;
        }
    }
}

// changelist toolbar
#changelist #toolbar {
    background: transparent;
    border: 0;

    * {
        box-sizing: border-box;
    }

    label {
        display: none;
    }

    .submit-button {
        position: absolute;
        top: 0;
        right: 0;
        height: 25px;
        padding: 1px 6px 0 4px;
        border: 0;
        box-shadow: none;
        background: transparent;
        cursor: pointer;
        color: $gray-400;

        .icon {
            font-size: 20px;
        }
    }

    #changelist-search {
        position: relative;
        box-sizing: border-box;
        white-space: nowrap;

        input#searchbar {
            width: 100%;
            height: 25px;
            padding: 3px 8px;
        }

        input[type="submit"] {
            visibility: hidden;
        }
    }

    // desktop
    @media (min-width: $tablet-width) {
        position: absolute;
        right: 0;
        top: 10px;
        width: 200px !important;
        margin: 0 !important;
        padding: 0;

        #changelist-search {
            .small {
                position: absolute;
                left: -30px;
                top: 3px;
                transform: translateX(-100%);
            }
        }
    }

    @media (max-width: $tablet-width - 1px) {
        padding-left: 0;
        padding-right: 0;

        #changelist-search {
            .small {
                display: block;
                margin-top: 5px;
            }
        }
    }
}


// changelist filter
#changelist-filter {
    position: absolute;
    top: 45px;
    width: 200px;
    padding-bottom: 70px;
    background: transparent;
    border: 0;

    h2 {
        display: none;
    }

    h3 {
        padding: 6px 15px 7px 15px;
        margin-top: 0;
        margin-bottom: 0;
        border: solid 1px $gray-300;
        background: $gray-50;
        text-transform: lowercase;
    }

    ul {
        padding: 8px 0 10px 15px;
        margin: 0 0 10px 0;

        &,
        &:last-child {
            border: solid 1px $gray-300;
            border-top: 0;
        }
    }

    li {
        margin-left: -15px;
        padding-left: 20px;
    }

    li.selected {
        //border-left-color: $gray-600;
        padding-left: 15px;

        a {
            color: $blue-dark;
        }
    }

    // Collapsibles
    h3.collapsible {
        position: relative;
        cursor: pointer;

        .collapse-icon {
            display: block;
            width: 14px;
            height: 14px;
            position: absolute;
            top: 9px;
            right: 7px;
            background-image: url('/s/admin/img/sorting-icons.svg');
            background-repeat: no-repeat;
            background-position: 0 -56px;
        }

        &.collapsible-open {
            .collapse-icon {
                background-position: 0 -28px;
            }
        }

        &:hover {
            background: $gray-150;
        }
    }

    h3.collapsible + ul {
        overflow: hidden;

        &:not(.collapsible-open) {
            height: 0;
            padding-top: 0;
            padding-bottom: 0;
            border-top: 0;
            border-bottom: 0;
        }
    }

    // Mobile & Tablet
    @media(max-width: $tablet-width - 1px) {
        display: none;
    }

    // Desktop
    @media(min-width: $desktop-width) {
        width: 200px;
    }
}

// change list
#changelist {

    .actions {
        padding-left: 0;
        padding-right: 0;

        select {
            margin-left: 0;
            font-size: 13px;
            color: $gray-500;

            &:focus,
            option:not(:first-child) {
                color: $gray-900;
            }
        }
    }

    table {
        border: solid 1px $gray-300;
    }

    &.filtered {
        table {
            border-right: solid 1px $gray-300;
        }
    }

    .toplinks {
        border-bottom: 0;
    }

    .paginator {
        border-top: 0;
    }

    #result_list {

        td,
        th {
            position: relative;
            height: 100%;
        }

        td {
            padding: 10px 8px;
        }

        tbody th a:only-child,
        tbody td a:only-child {
            display: inline-block;
            width: 100%;
            height: 100%;

            &:not(:hover) {
                .icon {
                    color: $gray-700;
                }
            }
        }

        .icon {
            font-size: 50px;
            padding: 10px 30px;
        }
    }

    // tablet up
    @media (min-width: $tablet-width) {
        &.filtered {
            .actions,
            .results,
            .paginator,
            div.xfull {
                margin-right: 230px;
            }
        }
    }

    // mobile
    @media(max-width: $tablet-width - 1px) {
        .xfull,
        .results {
            margin-right: 0;
        }

        .toplinks {
            float: none;
            width: 100%;
        }

        .actions {
            display: none !important;
        }

        table {
            th.action-checkbox-column,
            td.action-checkbox {
                display: none;
            }
        }

        &.filtered {
            #toolbar,
            .actions,
            .results,
            .paginator,
            div.xfull {
                margin-right: 0;
            }
        }
    }
}


// tables
table {
    thead {
        th {
            border: solid 1px $gray-300;
            color: $gray-700;
            background: $gray-50;

            &.sorted {
                color: $gray-900;

                .text {
                    a:link,
                    a:visited,
                    a:focus,
                    a:hover {
                        color: $gray-900;
                        font-weight: 600;
                    }
                }
            }
        }
    }

    th,
    td {
        border-bottom: solid 1px $gray-200;
    }
}


// changeforms
.change-form {
    #content {
        padding-bottom: 50px;
    }
}

.change-form .related-object-info {
    margin-bottom: 20px;
    box-sizing: border-box;

    .icon {
        font-size: 48px;
        color: $gray-500;

        &:hover {
            color: $blue;
        }
    }

    .media-related-item-list {
        padding-left: 20px;
    }

    @media (min-width: $tablet-width) {
        float: right;
        background: $white;
        padding: 10px 0 60px 60px;
        max-width: 260px;
    }
}

form .aligned {
    margin-bottom: 10px;

    .help,
    div.help {
        font-size: 12px;
        clear: left;
    }

    div.help,
    input + div.help,
    textarea + div.help,
    select + div.help {
        padding-top: 10px;
        padding-left: 4px;

        &:last-child {
            margin-left: 0;
        }
    }

    label + p,
    label + div.readonly,
    p.file-upload {
        margin-left: 0;
    }

    .clearable-file-input {
        display: inline-block;
        margin-left: 10px;

        label {
            display: inline !important;
            color: $red;
        }
    }

    .form-row {
        @include clearfix;
        padding: 10px 0 15px 0;

        &:last-child {
            border-bottom: 0;
        }

        >div {
            margin-top: -4px;
        }

        >div:not(.checkbox-row):not(.field-box) {
            label:not(.vCheckboxLabel) {
                display: block;
                float: none;
                width: auto;
                padding-top: 0;
            }

            > .vTextField,
            > .vLargeTextField,
            > .vXMLLargeTextField,
            > .vIntegerField,
            > .vBigIntegerField,
            > .vURLField {
                max-width: calc(100% - 15px);
            }

            > .vTextField,
            > .vLargeTextField,
            > .vXMLLargeTextField {
                width: calc(100% - 15px);
                max-width: 800px;
            }

            > .vForeignKeyRawIdAdminField {
                max-width: calc(100% - 36px);
            }

            .datetime {
                padding-left: 10px;

                input.vDateField,
                input.vTimeField {
                    width: 78px;
                    margin-left: 50px;
                }

                input.vTimeField {
                    position: relative;
                    left: -2px;
                }
            }
        }

        .field-box {
            label {
                float: none;
            }

            &:last-child {
                margin-bottom: -10px;
            }

            &:not(:last-child) {
                padding-right: 30px;
                margin-bottom: 10px;
            }

            .vCheckboxLabel.inline {
                margin-top: 14px;
            }

            @media(max-width: $tablet-width - 1px) {
                clear: both;
                margin-bottom: 15px;
            }
        }

        .related-widget-wrapper {
            overflow: visible;
        }

        .related-lookup {
            display: inline-block;
            width: auto;
            height: 26px;
            background: transparent;
            text-decoration: none;
            vertical-align: middle;
            margin: 0;
            padding: 0 5px;
            color: $gray-900;

            &::before {
                @include material-icons;
                display: inline-block;
                vertical-align: middle;
                content: 'search';
                font-size: 26px;
                width: 26px;
                height: 26px;
                margin-right: 5px;
            }

            &:hover {
                color: $blue;
            }
        }

        // mobile
        @media(max-width: $tablet-width - 1px) {
            padding-left: 0;
            padding-right: 0;
        }
    }
}

.form-row {
    overflow: visible;

    &.errors {
    }
}

.form-row.errors,
.field-box.errors {
    background: $yellow;
    border: solid rgba($red, 0.1) 1px !important;
    margin-bottom: -1px;

    .errorlist {
        background: $yellow;
        margin-left: 0;
        padding-left: 0;
    }
}

.change-form fieldset.module:last-of-type {
    .form-row:last-of-type {
        border-bottom: 0;
    }
}

.errornote {
    background: $red;
    color: $white;
}

fieldset.module {
    h2 {
        margin-bottom: 15px;
        background: transparent;
        border: 0;
        border-bottom: solid 1px $gray-400;
    }
}

.change-form .submit-row {
    box-sizing: border-box;
    position: fixed;
    z-index: 1000;
    bottom: 0;
    left: 0;
    width: 100%;
    margin: 0;
    padding: 10px 20px;
    background: $gray-100;
    border: 0;
    border-top: solid 1px $gray-300;
    border-radius: 0;

    @media(min-width: $desktop-width) {
        input,
        a.deletelink {
            transform: scale(0.9);
        }
    }

    &.static {
        position: static;
        background: transparent;
        border: 0;
        padding: 0;
        text-align: left;

        input.default {
            float: none;
            margin: 0;
        }
    }

    // mobile
    @media (max-width: $desktop-width - 1px) {
        // only show deault & delete buttons in mobile
        input:not(.default):not(.deletelink) {
            display: none;
        }
    }
}

// inlines
.inline-group {

    fieldset.module {
        h3 {
            padding: 10px;
            background: transparent;
            color: $gray-900;
            border-top: 0;
            font-weight: normal;

            span.delete {
                label {
                    cursor: pointer;
                    color: $gray-800;
                }

                input:checked + label {
                    color: $red;
                }
            }
        }
    }

    .inline-related {
        background: $gray-50;
        border: solid 1px $gray-300;

        &:not(:last-child) {
            margin-bottom: 20px;
        }

        h3 {
            margin-bottom: 0 !important;
            border-bottom: solid 1px $gray-300 !important;
        }

        .form-row {
            padding: 10px;
        }

        &.will-delete {
            > *:not(h3):not(.delete),
            h3 > *:not(.delete) {
                opacity: 0.4;
                filter: saturate(0);
            }
        }
    }

    b,
    .inline_label {
        font-size: 12px;
    }

    .tabular {
        border: 0;
    }

    div.add-row {
        padding: 10px;
        border: solid 1px $gray-300;
        background: $gray-100;

        a:not(:last-of-type) {
            margin-right: 15px;
        }
    }
}


// calendar widget
.calendar caption,
.calendarbox h2 {
    background: $blue !important;
    color: $white !important;
}

.calendarbox .calendarnav-previous,
.calendarbox .calendarnav-next {
    filter: invert(100%) contrast(200%);
}

// selector (filter)
.selector {
    .selector-available,
    .selector-chosen {
        h2,
        h3 {
            background: transparent;
            color: $gray-900;
            margin-bottom: 0;
            border-bottom: solid 1px $gray-400;
        }

        .selector-filter {
            > label {
                float: left !important;
            }
        }
    }

    select {
        background: $white;
    }

    .selector-chosen {
        select {
            height: 20.8em;
        }
    }
}

// change-history
#change-history {
    td:nth-child(2) {
        white-space: nowrap;
    }
}

// TODO: not currently using this, either remove or fix Popup component
.modal-popup {
    position: fixed;
    top: 0;
    left: 0;
    z-index: 3000;
    width: 100%;
    height: 100%;

    &,
    * {
        box-sizing: border-box;
    }

    .modal-popup-content {
        position: absolute;
        z-index: 10;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 80%;
        height: 80%;
        background: $white;
    }

    .popup-iframe {
        width: 100%;
        height: 100%;
        border: 0;
    }

    .modal-close-button {
        position: absolute;
        top: -20px;
        right: -20px;
        width: 28px;
        height: 28px;
        font-size: 28px;
        line-height: 1;
        color: $gray-900;
        background: $white;
        border-radius: 50%;
    }

    .modal-overlay {
        position: fixed;
        top: 0;
        left: 0;
        width: 100vw;
        height: 100vh;
        background: rgba($black, 0.8);
    }
}
